package com.ruoyi.market.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.idgen.IdGenerate;
import com.ruoyi.market.domain.MarketAdvertisingAward;
import com.ruoyi.market.domain.MarketAdvertisingCompany;
import com.ruoyi.market.domain.vo.AdvertisingAwardQueryVo;
import com.ruoyi.market.domain.vo.AdvertisingCompanyQueryVo;
import com.ruoyi.market.mapper.MarketAdvertisingAwardMapper;
import com.ruoyi.market.service.MarketAdvertisingAwardService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Objects;

@Service
public class MarketAdvertisingAwardServiceImpl extends ServiceImpl<MarketAdvertisingAwardMapper, MarketAdvertisingAward>
        implements MarketAdvertisingAwardService {
    @Override
    public boolean insertAdvertisingAward(MarketAdvertisingAward advertisingAward) {
        advertisingAward.setId(IdGenerate.nextId());
        advertisingAward.setCreateTime(new Date());
        return this.save(advertisingAward);
    }

    @Override
    public boolean updateAdvertisingAward(MarketAdvertisingAward advertisingAward) {
        return this.updateById(advertisingAward);
    }

    @Override
    public boolean deleteAdvertisingAward(MarketAdvertisingAward advertisingAward) {
        return this.removeById(advertisingAward);
    }

    @Override
    public Page<MarketAdvertisingAward> advertisingAwardList(Page page, AdvertisingAwardQueryVo advertisingAwardQueryVo) {
        LambdaQueryWrapper<MarketAdvertisingAward> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(!Objects.isNull(advertisingAwardQueryVo.getAwardId()), MarketAdvertisingAward::getAwardId, advertisingAwardQueryVo.getAwardId());
        queryWrapper.eq(!Objects.isNull(advertisingAwardQueryVo.getVideoId()), MarketAdvertisingAward::getVideoId, advertisingAwardQueryVo.getVideoId());
        queryWrapper.lt(!Objects.isNull(advertisingAwardQueryVo.getCreateTimeStart()), MarketAdvertisingAward::getCreateTime, advertisingAwardQueryVo.getCreateTimeStart());
        queryWrapper.gt(!Objects.isNull(advertisingAwardQueryVo.getCreateTimeEnd()), MarketAdvertisingAward::getCreateTime, advertisingAwardQueryVo.getCreateTimeEnd());
        return this.page(page, queryWrapper);
    }
}
