package com.ruoyi.market.service.impl;



import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.market.domain.MarketAdvertisingLibrary;
import com.ruoyi.market.domain.vo.AdvertisingLibraryQueryVo;
import com.ruoyi.market.mapper.MarketAdvertisingLibraryMapper;
import com.ruoyi.market.service.MarketAdvertisingLibraryService;
import com.ruoyi.common.utils.idgen.IdGenerate;
import org.springframework.stereotype.Service;

import java.util.Objects;


@Service
public class MarketAdvertisingLibraryServiceImpl extends ServiceImpl<MarketAdvertisingLibraryMapper, MarketAdvertisingLibrary>
        implements MarketAdvertisingLibraryService {


    @Override
    public boolean insertAdvertisingLibrary(MarketAdvertisingLibrary advertisingLibrary) {
        advertisingLibrary.setId(IdGenerate.nextId());
        return this.save(advertisingLibrary);
    }

    @Override
    public boolean updateAdvertisingLibrary(MarketAdvertisingLibrary advertisingLibrary) {
        return this.updateById(advertisingLibrary);
    }

    @Override
    public boolean deleteAdvertisingLibrary(MarketAdvertisingLibrary advertisingLibrary) {
        return this.removeById(advertisingLibrary);
    }

    @Override
    public Page<MarketAdvertisingLibrary> advertisingLibraryList(Page page,AdvertisingLibraryQueryVo advertisingLibraryQueryVo) {
        LambdaQueryWrapper<MarketAdvertisingLibrary> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(!Objects.isNull(advertisingLibraryQueryVo.getVideoTitle()), MarketAdvertisingLibrary::getVideoTitle, advertisingLibraryQueryVo.getVideoTitle());
        queryWrapper.eq(!Objects.isNull(advertisingLibraryQueryVo.getVideoCompany()), MarketAdvertisingLibrary::getVideoCompany, advertisingLibraryQueryVo.getVideoCompany());
        queryWrapper.eq(!Objects.isNull(advertisingLibraryQueryVo.getVideoUrl()), MarketAdvertisingLibrary::getVideoCover, advertisingLibraryQueryVo.getVideoUrl());
        return this.page(page, queryWrapper);
    }

}
