package com.ruoyi.market.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.idgen.IdGenerate;
import com.ruoyi.market.domain.MarketAdvertisingProbability;
import com.ruoyi.market.domain.vo.AdvertisingProbabilityQueryVo;
import com.ruoyi.market.mapper.MarketAdvertisingProbabilityMapper;
import com.ruoyi.market.service.MarketAdvertisingProbabilityService;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Objects;

@Service
public class MarketAdvertisingProbabilityServiceImpl extends ServiceImpl<MarketAdvertisingProbabilityMapper, MarketAdvertisingProbability>
    implements MarketAdvertisingProbabilityService {
    @Override
    public boolean insertAdvertisingProbability(MarketAdvertisingProbability advertisingProbability) {
        advertisingProbability.setId(IdGenerate.nextId());
        advertisingProbability.setCreateTime(new Date());
        return this.save(advertisingProbability);
    }

    @Override
    public boolean updateAdvertisingProbability(MarketAdvertisingProbability advertisingProbability) {
        return updateById(advertisingProbability);
    }

    @Override
    public boolean deleteAdvertisingProbability(MarketAdvertisingProbability advertisingProbability) {
        MarketAdvertisingProbability probability = this.getById(advertisingProbability.getId());
        if (Objects.isNull(probability)) {
            throw new RuntimeException("广告概率不存在");
        }
        return this.removeById(advertisingProbability);
    }

    @Override
    public Page<MarketAdvertisingProbability> advertisingProbabilityList(Page page, AdvertisingProbabilityQueryVo advertisingProbabilityQueryVo) {
        LambdaQueryWrapper<MarketAdvertisingProbability> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(!Objects.isNull(advertisingProbabilityQueryVo.getCompanyId()), MarketAdvertisingProbability::getCompanyId, advertisingProbabilityQueryVo.getCompanyId());
        queryWrapper.lt(!Objects.isNull(advertisingProbabilityQueryVo.getCreateTimeStart()), MarketAdvertisingProbability::getCreateTime, advertisingProbabilityQueryVo.getCreateTimeStart());
        queryWrapper.gt(!Objects.isNull(advertisingProbabilityQueryVo.getCreateTimeEnd()), MarketAdvertisingProbability::getCreateTime, advertisingProbabilityQueryVo.getCreateTimeEnd());
        queryWrapper.eq(!Objects.isNull(advertisingProbabilityQueryVo.getCreateBy()), MarketAdvertisingProbability::getCreateBy, advertisingProbabilityQueryVo.getCreateBy());
        return this.page(page, queryWrapper);
    }
}
