package com.ruoyi.market.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.market.domain.MarketAwardLibrary;
import com.ruoyi.market.domain.vo.AwardQueryVo;
import com.ruoyi.market.mapper.MarketAwardLibraryMapper;
import com.ruoyi.market.service.MarketAwardLibraryService;
import org.springframework.stereotype.Service;

import java.util.Objects;

@Service
public class MarketAwardLibraryServiceImpl extends ServiceImpl<MarketAwardLibraryMapper, MarketAwardLibrary>
        implements MarketAwardLibraryService {

    /**
     * 查询奖品列表
     *
     * @param page
     * @param awardQueryVo
     * @return
     */
    @Override
    public Page<MarketAwardLibrary> awardLibraryList(Page page, AwardQueryVo awardQueryVo) {
        LambdaQueryWrapper<MarketAwardLibrary> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(MarketAwardLibrary::getIsDelete, "0");
        queryWrapper.like(!Objects.isNull(awardQueryVo.getAwardName()), MarketAwardLibrary::getAwardName, awardQueryVo.getAwardName());
        return this.page(page, queryWrapper);
    }

    /**
     * 删除奖品
     *
     * @param awardId
     * @return
     */
    @Override
    public boolean delAward(String awardId) {
        MarketAwardLibrary award = this.getById(awardId);
        if (Objects.isNull(award)) {
            throw new RuntimeException("奖品不存在");
        }
        award.setIsDelete("1");
        this.updateById(award);
        return true;
    }
}
