package com.ruoyi.web.controller.market;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.market.domain.MarketAdvertisingAward;
import com.ruoyi.market.domain.MarketAdvertisingCompany;
import com.ruoyi.market.domain.vo.AdvertisingAwardQueryVo;
import com.ruoyi.market.domain.vo.AdvertisingCompanyQueryVo;
import com.ruoyi.market.service.MarketAdvertisingAwardService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Api(tags = "广告奖品管理")
@RestController
@RequestMapping("/market/advertisingAward")
public class MarketAdvertisingAwardController extends BaseController {
    @Resource
    private MarketAdvertisingAwardService marketAdvertisingAwardService;

    @ApiOperation("添加广告奖品")
    @PostMapping("/add")
    public AjaxResult add(@Validated @RequestBody MarketAdvertisingAward marketAdvertisingAward) {
            marketAdvertisingAward.setCreateBy(getUsername());
        return marketAdvertisingAwardService.insertAdvertisingAward(marketAdvertisingAward) ?
                success("成功") : error("失败");
    }

    @ApiOperation("修改广告奖品")
    @PostMapping("/update")
    public AjaxResult update(@Validated @RequestBody MarketAdvertisingAward marketAdvertisingAward) {

        return marketAdvertisingAwardService.updateAdvertisingAward(marketAdvertisingAward) ?
                success("成功") : error("失败");
    }

    @ApiOperation("删除广告奖品")
    @PostMapping("/delete")
    public AjaxResult delete(@Validated @RequestBody MarketAdvertisingAward marketAdvertisingAward) {
        return marketAdvertisingAwardService.deleteAdvertisingAward(marketAdvertisingAward) ?
                success("成功") : error("失败");
    }

    @ApiOperation("获取广告奖品列表")
    @PostMapping("/list")
    public AjaxResult list(@Validated @RequestBody AdvertisingAwardQueryVo advertisingAwardQueryVo)
    {
        Page page = advertisingAwardQueryVo.getPage();
        return AjaxResult.success(marketAdvertisingAwardService.advertisingAwardList(page, advertisingAwardQueryVo));
    }
}
