package com.ruoyi.web.controller.market;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.market.domain.MarketAdvertisingProbability;
import com.ruoyi.market.domain.vo.AdvertisingProbabilityQueryVo;
import com.ruoyi.market.service.MarketAdvertisingProbabilityService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@Api(tags = "广告概率管理")
@RestController
@RequestMapping("/market/advertisingProbability")
public class MarketAdvertisingProbabilityController extends BaseController {
    @Resource
    private MarketAdvertisingProbabilityService marketAdvertisingProbabilityService;

    @ApiOperation("添加广告概率")
    @PostMapping("/add")
    public AjaxResult add(@Validated @RequestBody MarketAdvertisingProbability marketAdvertisingProbability) {
            marketAdvertisingProbability.setCreateBy(getUsername());
        return marketAdvertisingProbabilityService.insertAdvertisingProbability(marketAdvertisingProbability) ?
                success("成功") : error("失败");
    }

    @ApiOperation("修改广告概率")
    @PostMapping("/update")
    public AjaxResult update(@Validated @RequestBody MarketAdvertisingProbability marketAdvertisingProbability) {
        return marketAdvertisingProbabilityService.updateAdvertisingProbability(marketAdvertisingProbability) ?
                success("成功") : error("失败");
    }

    @ApiOperation("删除广告概率")
    @PostMapping("/delete")
    public AjaxResult delete(@Validated @RequestBody MarketAdvertisingProbability marketAdvertisingProbability) {
        return marketAdvertisingProbabilityService.deleteAdvertisingProbability(marketAdvertisingProbability) ?
                success("成功") : error("失败");
    }

    @ApiOperation("获取广告列表")
    @PostMapping("/list")
    public AjaxResult list(@Validated @RequestBody AdvertisingProbabilityQueryVo advertisingProbabilityQueryVo)
    {
        Page page = advertisingProbabilityQueryVo.getPage();
        return AjaxResult.success(marketAdvertisingProbabilityService.advertisingProbabilityList(page, advertisingProbabilityQueryVo));
    }
}
